/*Copyright (C) 2007 Cassarin-Grand Arthur (Zoloom)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#include "POLSCapp.h"
#include "Fenp.h"
#include "Fent.h"
#include "Fenconfig.h"
#include "Fennew.h"
#include "Fenupscript.h"

#define ID_ADDNEW 100
#define ID_PRESSTBUTTON 101

using namespace std;

Fennew::Fennew(wxWindow *parent) : wxFrame(parent, wxID_ANY,_("Nouveau script"))
{
	SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));
	wxIcon icoFenp(_T("images/document-new.png")); //declaration de l'icone
	SetIcon(icoFenp); //on le lie a la fenetre
	
	txtcNameNew = new wxTextCtrl(this, -1, _T(""), wxDefaultPosition, wxSize(275,25));
	txtcEditorNew = new wxTextCtrl(this, -1, _T(""), wxDefaultPosition, wxSize(275,25));
	txtcWebsiteNew = new wxTextCtrl(this, -1, _T(""), wxDefaultPosition, wxSize(275,25));
	txtcNickNameNew = new wxTextCtrl(this, -1, _T(""), wxDefaultPosition, wxSize(275,25));
	txtcGameNameNew = new wxTextCtrl(this, -1, _T(""), wxDefaultPosition, wxSize(275,25));
	//txtcAutorunExeCDNew = new wxTextCtrl(this, -1, _T(""), wxDefaultPosition, wxSize(275,25));
		
	boxsNameNew = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Nom du jeu"));
	boxsEditorNew = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Editeur du jeu"));
	boxsWebsiteNew = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Site web du jeu"));
	boxsNickNameNew = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Votre pseudonyme"));
	boxsGameNameNew = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Titre du jeu (chiffres et lettres uniquement)"));
	//boxType1New = new wxBoxSizer(wxHORIZONTAL);
	//boxType2New = new wxBoxSizer(wxHORIZONTAL);
	boxButtonNew = new wxBoxSizer(wxHORIZONTAL);
	//boxsTypeCDNew = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Nom de l'executable autorun"));
	boxMainNew = new wxBoxSizer(wxVERTICAL);	
	
	buttonAddNew = new wxButton(this, ID_ADDNEW, _("Ajouter"), wxDefaultPosition, wxDefaultSize);
	
	//buttontTypeScriptCDNew = new wxToggleButton(this, ID_PRESSTBUTTON, _("DVD/CD-ROM based game script"), wxDefaultPosition, wxDefaultSize);
	//buttontTypeScriptDCNew = new wxToggleButton(this, ID_PRESSTBUTTON, _("Online client based game script"), wxDefaultPosition, wxDefaultSize);
	//buttontTypeScriptLCNew = new wxToggleButton(this, ID_PRESSTBUTTON, _("Local Client based game script"), wxDefaultPosition, wxDefaultSize);
	
	boxsNameNew->Add(txtcNameNew, 2, 10);
	boxsEditorNew->Add(txtcEditorNew, 2, 10);
	boxsWebsiteNew->Add(txtcWebsiteNew, 2, 10);
	boxsNickNameNew->Add(txtcNickNameNew, 2, 10);
	boxsGameNameNew->Add(txtcGameNameNew, 2, 10);
	
	boxButtonNew->Add(buttonAddNew, 1, wxALIGN_CENTER, 0);
	
	/*boxType1New->Add(buttontTypeScriptCDNew, 0, 10);
	boxType1New->Add(buttontTypeScriptDCNew, 0, 10);
	
	boxType2New->Add(buttontTypeScriptLCNew, 0, 10);
	
	boxsTypeCDNew->Add(txtcAutorunExeCDNew, 0, 0);
	boxsTypeDCNew->Add(txtcAutorunExeCDNew, 0, 0);
	boxsTypeLCNew->Add(txtcAutorunExeCDNew, 0, 0);*/
	
	boxMainNew->Add(boxsNameNew, 0, wxEXPAND, 5);
	boxMainNew->Add(boxsEditorNew, 0, wxEXPAND, 5);
	boxMainNew->Add(boxsWebsiteNew, 0, wxEXPAND, 5);
	boxMainNew->Add(boxsNickNameNew, 0, wxEXPAND, 5);
	boxMainNew->Add(boxsGameNameNew, 0, wxEXPAND, 10);
	//boxMainNew->AddSpacer(8);
	//boxMainNew->Add(boxType1New, 0, wxALIGN_CENTER, 0);
	//boxMainNew->Add(boxType2New, 0, wxALIGN_CENTER, 10);
	boxMainNew->AddSpacer(8);
	//boxMainNew->Add(boxsTypeCDNew, 0, 10);
	//boxMainNew->AddSpacer(8);
	boxMainNew->Add(boxButtonNew, 0, wxALIGN_CENTER, 0);
	
	SetSizerAndFit(boxMainNew);
	
	//boxsTypeCDNew->Show(false);
	
}

Fennew::~Fennew()
{
	
}

void Fennew::AddGeneralInformationsNew(wxCommandEvent& WXUNUSED(event))
{
	
	wxString textsAddedBufferNew = _T("");
	wxString txtsPresentation1 = _T("presentation ");
	wxString txtsPresentation = _T("");
	wxString bufferTextNew = _T("");
			
	wxString txtsNameGameNew = txtcNameNew->GetValue();
	wxString txtsEditorGameNew = txtcEditorNew->GetValue();
	wxString txtsWebsiteGameNew = txtcWebsiteNew->GetValue();
	wxString txtsNickNameGameNew = txtcNickNameNew->GetValue();
	wxString txtsGameNameGameNew = txtcGameNameNew->GetValue();
	
	
	char bufferFileNewBaseData[2048] = _T("");
	int readLinesNewBaseData = 0;
	ifstream fileNewData(_T("data/new"),ios::in);
	
	while(fileNewData.getline(bufferFileNewBaseData,2048) && !fileNewData.eof())
	{
		if (readLinesNewBaseData == 0)
		{
				bufferTextNew = bufferTextNew + bufferFileNewBaseData;
				readLinesNewBaseData++;
		}
			
		else
		{
				bufferTextNew = bufferTextNew + _T("\n");
				bufferTextNew = bufferTextNew + bufferFileNewBaseData;
				readLinesNewBaseData++;
		}			
	}
				
	fileNewData.close();	
		
	Fenp* parent=(Fenp*)GetParent();
	txtsPresentation = txtsPresentation1 + _T("\"") + txtsNameGameNew + _T("\"") + _T(" ") + _T("\"") + txtsEditorGameNew + _T("\"") + _T(" ") + _T("\"") + txtsWebsiteGameNew + _T("\"") + _T(" ") + _T("\"") + txtsNickNameGameNew + _T("\"") + _T(" ") + _T("\"") + txtsGameNameGameNew + _T("\"");	
	textsAddedBufferNew = bufferTextNew + _T("\n\n") + txtsPresentation;
	parent->CatchAddedFunctionFromFennew(textsAddedBufferNew);
		
}

/*void Fennew::DetectToogleButton(wxCommandEvent& WXUNUSED(event))
{
	if (buttontTypeScriptCDNew->GetValue() == true)
	{
		buttontTypeScriptDCNew->SetValue(false);
		buttontTypeScriptLCNew->SetValue(false);
		ManageBox(1);
	}
	
	if (buttontTypeScriptDCNew->GetValue() == true)
	{
		buttontTypeScriptCDNew->SetValue(false);
		buttontTypeScriptLCNew->SetValue(false);
		ManageBox(2);
	}
	
	if (buttontTypeScriptLCNew->GetValue() == true)
	{
		buttontTypeScriptDCNew->SetValue(false);
		buttontTypeScriptCDNew->SetValue(false);
		ManageBox(1);
	}
	
	else
	{return;}
}

void Fennew::ManageBox(int mode)
{
	if (mode == 1)
	{
		
	}
	
	if (mode == 2)
	{
		
	}
	
	if (mode == 3)
	{
		
	}
}*/

BEGIN_EVENT_TABLE( Fennew, wxFrame)

EVT_BUTTON(ID_ADDNEW, Fennew::AddGeneralInformationsNew)
//EVT_TOGGLEBUTTON(ID_PRESSTBUTTON, Fennew::DetectToogleButton)

END_EVENT_TABLE()
